/*
SCOPO: Emulare il comando ls -l
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>  
#include <sys/dir.h>
#include <dirent.h>
#include <time.h>
#include "mylib.h"
#include <string.h> 

int main(int argc, char *argv[]) {
	
   
	DIR *d; /* puntatore alla directory */
	struct dirent *dentry; /* puntatore alla entry della directory*/
	char *dir;  /* nome della directory*/ 
	char *name; /* nome della entry della directory */
	char *conc; /* stringa che contiene: directory/name_entry*/
	
        struct stat file_stat;

	if (argc != 2) {
		printf("usage: myls <dirname>");
		exit(1);	
	} else {
	
		/*
			Apertura delle directory argv[1]
		*/

		if((d = opendir(argv[1])) == NULL)
			syserr("myls", "opendir");	
		/* 
			Ciclo per tutte le entry della directory
		*/	
	
		dir=argv[1];
		conc=argv[1];
		for(dentry = readdir(d); dentry != NULL; dentry = readdir(d)) {	

		  name = dentry->d_name;
		  printf("%s ", name);			
			
			/* 
				Recupero la struttura stat per la entry definita da name.
				La struttura stat contiene tutte le informazioni che vengono
				visualizzate dal comando ls -l.
				Vedere il manuale di stat per i dettagli: man 2 stat
			*/
		
		 /*costruzione della stringa relativa al path del file*/	
		 conc = strcat(conc,"/");
		 conc=strcat(conc,name);
		 stat(conc, &file_stat);
			
			/*
				Controllo il tipo del file
			*/
			
					
			if((file_stat.st_mode & S_IFMT) == S_IFDIR) { /* � una directory? */
				printf("d");
			} else if ((file_stat.st_mode & S_IFMT) == S_IFBLK) { /* � un device a blocchi? */
				printf("b");
			} else if ((file_stat.st_mode & S_IFMT) == S_IFCHR) { /* � un device a caratteri? */
				printf("c");
			} else if ((file_stat.st_mode & S_IFMT) == S_IFREG) { /* � un file normale? */
				printf("-");
			}
			/* stampa le protezioni*/
			printf("%o ", file_stat.st_mode & 0777);
			
			/* stampa il numero di hard link*/
			printf("%d ", file_stat.st_nlink);
			
			/* stampa lo userd id */
			printf("%d ", file_stat.st_uid);
		
			/* stampa il group id */
			printf("%d ", file_stat.st_gid);
			
			/* stampa la dimensione in bytes */
			printf("%d ", file_stat.st_size);	
			
			/* stampa il tempo di ultima modifica*/
			printf("%s",  ctime(&file_stat.st_mtime));		

		/*operazione necessaria per effettuare correttamente la concatenazione nel prossimo ciclo*/
		conc=strcpy(conc,dir); 
		}
	}
  }	
